var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function rows() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var action = arguments[1];


  var gridValues = [12, 6, 4, 3];

  switch (action.type) {

    case 'ADD_ROW':
      return [].concat(state, [{
        id: Math.random().toString(36).substring(20),
        columns: [{
          className: "col-md-12",
          code: Math.random().toString(36).substring(20)
        }]
      }]);

    case 'REMOVE_ROW':
      return [].concat(state.slice(0, action.index), state.slice(action.index + 1));

    case 'ADD_COLUMN':
      var nextGridSize = gridValues[state[action.index].columns.length];
      if (!nextGridSize) return state;
      return [].concat(state.slice(0, action.index), [_extends({}, state[action.index], {
        columns: [].concat(state[action.index].columns.map(function (col) {
          return _extends({}, col, { className: 'col-md-' + nextGridSize });
        }), [{
          className: 'col-md-' + nextGridSize,
          code: Math.random().toString(36).substring(20)
        }])
      })], state.slice(action.index + 1));

    case 'REMOVE_COLUMN':
      console.log('row and columns', action);
      var prevGridSize = gridValues[state[action.rowIndex].columns.length - 2];
      console.log(prevGridSize);
      if (!prevGridSize) return state;
      return [].concat(state.slice(0, action.rowIndex), [_extends({}, state[action.rowIndex], {
        columns: [].concat(state[action.rowIndex].columns.slice(0, action.columnIndex).map(function (col) {
          return _extends({}, col, { className: 'col-md-' + prevGridSize });
        }), state[action.rowIndex].columns.slice(action.columnIndex + 1).map(function (col) {
          return _extends({}, col, { className: 'col-md-' + prevGridSize });
        }))
      })], state.slice(action.rowIndex + 1));

    case 'MOVE_ROW':
      var newState = [].concat(state);
      var dragIndex = action.dragIndex,
          hoverIndex = action.hoverIndex;

      var dragRow = state[dragIndex];

      newState.splice(dragIndex, 1);
      newState.splice(hoverIndex, 0, dragRow);

      return newState;

    case 'MOVE_COLUMN':
      var colDragIndex = action.colDragIndex,
          colHoverIndex = action.colHoverIndex,
          rowIndex = action.rowIndex;

      var columnState = [].concat(state[rowIndex].columns);
      var dragColumn = state[rowIndex].columns[colDragIndex];

      columnState.splice(colDragIndex, 1);
      columnState.splice(colHoverIndex, 0, dragColumn);

      return [].concat(state.slice(0, rowIndex), [_extends({}, state[rowIndex], { columns: columnState
      })], state.slice(rowIndex + 1));

    default:
      return state;
  }
}

export default rows;