'use strict';

exports.__esModule = true;

var _dec, _dec2, _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _reactDnd = require('react-dnd');

var _itemTypes = require('./itemTypes');

var _itemTypes2 = _interopRequireDefault(_itemTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var columnSource = {
  beginDrag: function beginDrag(props) {
    return {
      index: props.i,
      rowIndex: props.index
    };
  }
};

var columnTarget = {
  hover: function hover(props, monitor, component) {

    var dragItem = monitor.getItem();
    var dragIndex = dragItem.index;

    var hoverIndex = props.i;
    var rowIndex = props.index;

    // Don't replace items with themselves
    if (dragIndex === hoverIndex) {
      return;
    }
    // Don't replace items between diferent rows
    if (dragItem.rowIndex !== rowIndex) {
      return;
    }

    // Determine rectangle on screen
    var hoverBoundingRect = _reactDom2.default.findDOMNode(component).getBoundingClientRect();

    // Get horizontal middle
    var hoverMiddleX = (hoverBoundingRect.right - hoverBoundingRect.left) / 2;

    // Determine mouse position
    var clientOffset = monitor.getClientOffset();

    // Get pixels to the left
    var hoverClientX = clientOffset.x - hoverBoundingRect.left;

    // Dragging to left
    if (dragIndex < hoverIndex && hoverClientX < hoverMiddleX) {
      return;
    }

    // Dragging to right
    if (dragIndex > hoverIndex && hoverClientX > hoverMiddleX) {
      return;
    }

    // Time to actually perform the action
    props.moveColumn(dragIndex, hoverIndex, rowIndex);

    // Note: we're mutating the monitor item here!
    monitor.getItem().index = hoverIndex;
  }
};

var Column = (_dec = (0, _reactDnd.DropTarget)(_itemTypes2.default.COLUMN, columnTarget, function (connect) {
  return {
    connectDropTarget: connect.dropTarget()
  };
}), _dec2 = (0, _reactDnd.DragSource)(_itemTypes2.default.COLUMN, columnSource, function (connect, monitor) {
  return {
    connectDragSource: connect.dragSource(),
    isDragging: monitor.isDragging()
  };
}), _dec(_class = _dec2(_class = function (_Component) {
  _inherits(Column, _Component);

  function Column(props) {
    _classCallCheck(this, Column);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.state = {
      isHovering: false
    };
    return _this;
  }

  Column.prototype.handleMouseOver = function handleMouseOver() {
    this.setState({ isHovering: true });
  };

  Column.prototype.handleMouseOut = function handleMouseOut() {
    this.setState({ isHovering: false });
  };

  Column.prototype.render = function render() {
    var _props = this.props,
        connectDragSource = _props.connectDragSource,
        connectDropTarget = _props.connectDropTarget,
        isDragging = _props.isDragging;

    var opacity = isDragging ? 0 : 1;
    var singleColumn = this.props.row.columns.length > 1 ? false : true;

    return connectDragSource(connectDropTarget(_react2.default.createElement(
      'div',
      { className: this.props.column.className,
        key: this.props.i,
        style: { opacity: opacity },
        onMouseEnter: this.handleMouseOver.bind(this),
        onMouseLeave: this.handleMouseOut.bind(this) },
      _react2.default.createElement(
        'div',
        { className: 'column_content' },
        this.state.isHovering && !singleColumn && _react2.default.createElement(
          'div',
          { className: 'column-actions' },
          _react2.default.createElement(
            'a',
            { className: 'column--delete', key: this.props.i, onClick: this.props.removeColumn.bind(this, this.props.index, this.props.i) },
            _react2.default.createElement('i', { className: 'fa fa-trash-o', 'aria-hidden': 'true' })
          )
        )
      )
    )));
  };

  return Column;
}(_react.Component)) || _class) || _class);
exports.default = Column;
module.exports = exports['default'];